Index: java/main/src/main/java/com/framsticks/params/types/ArrayListParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/ArrayListParam.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/types/ArrayListParam.java	(revision 84)
@@ -4,7 +4,8 @@
 import com.framsticks.params.ArrayListAccess;
 import com.framsticks.params.CastFailure;
-import com.framsticks.util.Casting;
-import com.framsticks.util.Containers;
-import com.framsticks.util.Numbers;
+import com.framsticks.params.ReassignResult;
+import com.framsticks.util.lang.Casting;
+import com.framsticks.util.lang.Containers;
+import com.framsticks.util.lang.Numbers;
 
 import java.util.ArrayList;
@@ -16,53 +17,53 @@
 public class ArrayListParam extends ListParam {
 
-    public ArrayListParam(String containedTypeName) {
-        super(containedTypeName);
-    }
+	public ArrayListParam(String containedTypeName) {
+		super(containedTypeName);
+	}
 
 
-    @Override
-    public Class getStorageType() {
-        return List.class;
-    }
+	@Override
+	public Class<?> getStorageType() {
+		return List.class;
+	}
 
-    @Override
-    public AccessInterface prepareAccessInterface(AccessInterface access) {
-        return new ArrayListAccess(access);
-    }
+	@Override
+	public AccessInterface prepareAccessInterface(AccessInterface access) {
+		return new ArrayListAccess(access);
+	}
 
-    @Override
-    public String computeAccessId() {
-        return "l " + containedTypeName;
-    }
+	@Override
+	public String computeAccessId() {
+		return "l " + containedTypeName;
+	}
 
-    @Override
-    public Object reassign(Object newValue, Object oldValue) throws CastFailure {
-        if (newValue == null) {
-            throw new CastFailure();
-        }
-        Integer size = Numbers.cast(newValue, Integer.class);
-        if (size != null) {
-            //return oldValue;
-            List list;
-            if (oldValue == null) {
-                list = new ArrayList();
-            } else {
-                list = Casting.tryCast(List.class, oldValue);
-                if (list == null) {
-                    throw new CastFailure();
-                }
-            }
-            Containers.resizeList(list, size);
-            return list;
-        }
-        if (oldValue != null) {
-            return oldValue;
-        }
-        return newValue;
-    }
+	@Override
+	public ReassignResult<List<?>> reassign(Object newValue, Object oldValue) throws CastFailure {
+		if (newValue == null) {
+			throw new CastFailure();
+		}
+		Integer size = Numbers.cast(newValue, Integer.class);
+		if (size != null) {
+			//return oldValue;
+			List<?> list;
+			if (oldValue == null) {
+				list = new ArrayList<Object>();
+			} else {
+				list = Casting.tryCast(List.class, oldValue);
+				if (list == null) {
+					throw new CastFailure();
+				}
+			}
+			Containers.resizeList(list, size);
+			return new ReassignResult<List<?>>(list);
+		}
+		if (oldValue != null) {
+			return new ReassignResult<List<?>>(Casting.throwCast(List.class, oldValue));
+		}
+		return new ReassignResult<List<?>>(Casting.throwCast(List.class, newValue));
+	}
 
-    @Override
-    public String getType() {
-        return "l " + getContainedTypeName();
-    }
+	@Override
+	public String getFramsTypeName() {
+		return "l " + getContainedTypeName();
+	}
 }
Index: java/main/src/main/java/com/framsticks/params/types/BinaryParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/BinaryParam.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/types/BinaryParam.java	(revision 84)
@@ -2,31 +2,37 @@
 
 import com.framsticks.params.CastFailure;
-import com.framsticks.util.Numbers;
+import com.framsticks.params.PrimitiveParam;
+import com.framsticks.params.ReassignResult;
+import com.framsticks.util.lang.Numbers;
 
 /**
  * @author Piotr Sniegowski
  */
-public class BinaryParam extends ValueParam {
+public class BinaryParam extends PrimitiveParam {
+
 	@Override
-	public Class getStorageType() {
+	public Class<?> getStorageType() {
 		return Integer.class;
 	}
 
-    @Override
-    public String getType() {
-        return "db";
-    }
+	@Override
+	public String getFramsTypeName() {
+		return "db";
+	}
 
-    @Override
-    public Object reassign(Object newValue, Object oldValue) throws CastFailure {
-        if (newValue instanceof String) {
-            Integer v = Numbers.parse((String) newValue, Integer.class);
-            if (v != null) {
-                return v;
-            }
-            throw new CastFailure();
-        }
-        return super.reassign(newValue, oldValue);
-    }
+	@Override
+	public ReassignResult<?> reassign(Object newValue, Object oldValue) throws CastFailure {
+		if (newValue instanceof String) {
+			Integer v = Numbers.parse((String) newValue, Integer.class);
+			if (v != null) {
+				return ReassignResult.create(v);
+			}
+			throw new CastFailure();
+		}
+		if (newValue instanceof Integer) {
+			return ReassignResult.create((Integer) newValue);
+		}
+		throw new CastFailure();
+	}
 
 }
Index: java/main/src/main/java/com/framsticks/params/types/BooleanParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/BooleanParam.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/types/BooleanParam.java	(revision 84)
@@ -2,46 +2,56 @@
 
 import com.framsticks.params.CastFailure;
+import com.framsticks.params.PrimitiveParam;
+import com.framsticks.params.ReassignResult;
 import com.framsticks.params.SinkInterface;
+import com.framsticks.util.lang.Numbers;
 
 /**
  * @author Piotr Sniegowski
  */
-public class BooleanParam extends DecimalParam {
-    @Override
-    public Class getStorageType() {
-        return Boolean.class;
-    }
+public class BooleanParam extends PrimitiveParam {
 
-    @Override
-    public Object reassign(Object newValue, Object oldValue) throws CastFailure {
+	public BooleanParam() {
+		def = false;
+	}
+
+	@Override
+	public Class<?> getStorageType() {
+		return Boolean.class;
+	}
+
+	@Override
+	public ReassignResult<Boolean> reassign(Object newValue, Object oldValue) throws CastFailure {
 		if (newValue instanceof Boolean) {
-			return newValue;
+			return ReassignResult.create((Boolean) newValue);
 		}
-        Object casted = super.reassign(newValue, oldValue);
-        if (casted instanceof Integer) {
-            Integer i = (Integer)casted;
-            if (i == 0) return false;
-            if (i == 1) return true;
-            throw new CastFailure();
-        }
-        /*
-        if (newValue instanceof String) {
-            if (newValue.equals("true")) return true;
-            if (newValue.equals("false")) return false;
-            throw new CastFailure();
-        }
-        */
-        throw new CastFailure();
-    }
+		if (newValue instanceof Integer) {
+			return ReassignResult.create(((Integer) newValue) != 0);
+		}
+		if (newValue instanceof String) {
+			if ("true".equals(newValue)) {
+				return ReassignResult.create(true);
+			}
+			if ("false".equals(newValue)) {
+				return ReassignResult.create(false);
+			}
+			Integer i = Numbers.cast(newValue, Integer.class);
+			if (i != null) {
+				return ReassignResult.create(i != 0);
+			}
+			throw new CastFailure();
+		}
+		throw new CastFailure();
+	}
 
-    @Override
-    public String getType() {
-        return "d 0 1";
-    }
+	@Override
+	public String getFramsTypeName() {
+		return "d 0 1";
+	}
 
-    @Override
-    public void save(SinkInterface sink, Object value) {
-        assert value instanceof Boolean;
-        sink.print(((Boolean)value) ? "1" : "0");
-    }
+	@Override
+	public void save(SinkInterface sink, Object value) {
+		assert value instanceof Boolean;
+		sink.print(((Boolean)value) ? "1" : "0");
+	}
 }
Index: java/main/src/main/java/com/framsticks/params/types/ColorParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/ColorParam.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/types/ColorParam.java	(revision 84)
@@ -1,19 +1,26 @@
 package com.framsticks.params.types;
+
+import com.framsticks.params.CastFailure;
+import com.framsticks.params.PrimitiveParam;
+import com.framsticks.params.ReassignResult;
 
 /**
  * @author Piotr Sniegowski
  */
-public class ColorParam extends ValueParam {
+public class ColorParam extends PrimitiveParam {
 
 	@Override
-	public Class getStorageType() {
-		return Void.class;
+	public Class<?> getStorageType() {
+		return Object.class;
 	}
 
-    @Override
-    public String getType() {
-        return "dc";
-    }
+	@Override
+	public String getFramsTypeName() {
+		return "dc";
+	}
 
+	public ReassignResult<Object> reassign(Object newValue, Object oldValue) throws CastFailure {
+		return ReassignResult.create(newValue);
+	}
 
 
Index: java/main/src/main/java/com/framsticks/params/types/DecimalParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/DecimalParam.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/types/DecimalParam.java	(revision 84)
@@ -2,39 +2,29 @@
 
 import com.framsticks.params.CastFailure;
-import com.framsticks.util.Numbers;
+import com.framsticks.params.ReassignResult;
 
 /**
  * @author Piotr Sniegowski
  */
-public class DecimalParam extends ValueParam {
+public class DecimalParam extends NumberParam<Integer> {
 
-	@Override
-	public boolean isNumeric() {
-		return true;
+	public DecimalParam() {
+		def = 0;
 	}
 
 	@Override
-	public Class getStorageType() {
+	public Class<?> getStorageType() {
 		return Integer.class;
 	}
 
+	@Override
+	public ReassignResult<Integer> reassign(Object newValue, Object oldValue) throws CastFailure {
+		return reassignNumber(newValue, oldValue, Integer.class);
+	}
 
-
-    @Override
-    public Object reassign(Object newValue, Object oldValue) throws CastFailure {
-        if (newValue instanceof String) {
-            Integer v = Numbers.parse((String)newValue, Integer.class);
-            if (v != null) {
-                return v;
-            }
-            throw new CastFailure();
-        }
-        return super.reassign(newValue, oldValue);
-    }
-
-    @Override
-    public String getType() {
-        return "d";
-    }
+	@Override
+	public String getFramsTypeName() {
+		return "d";
+	}
 
 
Index: java/main/src/main/java/com/framsticks/params/types/EnumParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/EnumParam.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/types/EnumParam.java	(revision 84)
@@ -1,5 +1,4 @@
 package com.framsticks.params.types;
 
-import java.util.ArrayList;
 import java.util.List;
 
@@ -9,5 +8,5 @@
 public class EnumParam extends DecimalParam {
 
-	ArrayList<String> enums;
+	List<String> enums;
 
 	/**
@@ -16,5 +15,5 @@
 	 * @param enums
 	 */
-	public EnumParam(ArrayList<String> enums) {
+	public EnumParam(List<String> enums) {
 		assert(enums != null);
 		this.enums = enums;
Index: java/main/src/main/java/com/framsticks/params/types/EventParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/EventParam.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/types/EventParam.java	(revision 84)
@@ -7,15 +7,13 @@
  */
 public class EventParam extends Param {
+
 	@Override
-	public Class getStorageType() {
+	public Class<?> getStorageType() {
 		return Void.class;
 	}
 
-    @Override
-    public String getType() {
-        return "e";
-    }
-
-
-
+	@Override
+	public String getFramsTypeName() {
+		return "e";
+	}
 }
Index: java/main/src/main/java/com/framsticks/params/types/FloatParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/FloatParam.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/types/FloatParam.java	(revision 84)
@@ -2,35 +2,29 @@
 
 import com.framsticks.params.CastFailure;
-import com.framsticks.util.Numbers;
+import com.framsticks.params.ReassignResult;
 
 /**
  * @author Piotr Sniegowski
  */
-public class FloatParam extends ValueParam {
+public class FloatParam extends NumberParam<Double> {
+
+	public FloatParam() {
+		def = 0.0;
+	}
+
 	@Override
-	public boolean isNumeric() {
-		return true;
-	}
-	@Override
-	public Class getStorageType() {
+	public Class<?> getStorageType() {
 		return Double.class;
 	}
 
 	@Override
-    public Object reassign(Object newValue, Object oldValue) throws CastFailure {
-        if (newValue instanceof String) {
-		    Double v = Numbers.parse((String)newValue, Double.class);
-            if (v != null) {
-                return v;
-            }
-            throw new CastFailure();
-        }
-        return super.reassign(newValue, oldValue);
+	public ReassignResult<Double> reassign(Object newValue, Object oldValue) throws CastFailure {
+		return reassignNumber(newValue, oldValue, Double.class);
 	}
 
-    @Override
-    public String getType() {
-        return "f";
-    }
+	@Override
+	public String getFramsTypeName() {
+		return "f";
+	}
 
 
Index: java/main/src/main/java/com/framsticks/params/types/ListParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/ListParam.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/types/ListParam.java	(revision 84)
@@ -1,10 +1,5 @@
 package com.framsticks.params.types;
 
-import com.framsticks.params.CastFailure;
-import com.framsticks.util.Casting;
-import com.framsticks.util.Containers;
-import com.framsticks.util.Numbers;
-
-import java.util.List;
+import com.framsticks.params.CompositeParam;
 
 /**
@@ -17,8 +12,3 @@
 	}
 
-
-
-
-
-
 }
Index: java/main/src/main/java/com/framsticks/params/types/NumberParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/NumberParam.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/params/types/NumberParam.java	(revision 84)
@@ -0,0 +1,38 @@
+package com.framsticks.params.types;
+
+import com.framsticks.params.CastFailure;
+import com.framsticks.params.Flags;
+import com.framsticks.params.PrimitiveParam;
+import com.framsticks.params.ReassignResult;
+import com.framsticks.util.lang.Casting;
+import com.framsticks.util.lang.Numbers;
+
+/**
+ * @author Piotr Sniegowski
+ */
+public abstract class NumberParam<T extends Number & Comparable<T>> extends PrimitiveParam {
+
+	@Override
+	public boolean isNumeric() {
+		return true;
+	}
+
+	protected ReassignResult<T> reassignNumber(Object newValue, Object oldValue, Class<T> type) throws CastFailure {
+		T v = null;
+		if (newValue instanceof String) {
+			v = Numbers.parse((String)newValue, type);
+		} else {
+			v = Casting.tryCast(type, newValue);
+		}
+		if (v == null) {
+			throw new CastFailure();
+		}
+		if (min != null && v.compareTo(getMin(type)) < 0) {
+			return new ReassignResult<T>(getMin(type), Flags.PSET_HITMIN);
+		}
+		if (max != null && v.compareTo(getMax(type)) > 0) {
+			return new ReassignResult<T>(getMax(type), Flags.PSET_HITMAX);
+		}
+		return ReassignResult.create(v);
+	}
+}
Index: java/main/src/main/java/com/framsticks/params/types/ObjectParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/ObjectParam.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/types/ObjectParam.java	(revision 84)
@@ -3,4 +3,6 @@
 import com.framsticks.params.AccessInterface;
 import com.framsticks.params.CastFailure;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.ReassignResult;
 
 /**
@@ -13,36 +15,28 @@
 	}
 
-    @Override
-    public String computeAccessId() {
-        return containedTypeName;
-    }
+	@Override
+	public String computeAccessId() {
+		return containedTypeName;
+	}
 
-    @Override
-	public Class getStorageType() {
+	@Override
+	public Class<?> getStorageType() {
 		return Object.class;
 	}
 
 	@Override
-	public boolean isEmptyAvailable() {
-		return true;
+	public ReassignResult<Object> reassign(Object newValue, Object oldValue) throws CastFailure {
+		return ReassignResult.create(newValue);
 	}
 
 	@Override
-	public Object reassign(Object newValue, Object oldValue) throws CastFailure {
-		return newValue;
+	public AccessInterface prepareAccessInterface(AccessInterface access) {
+		return access;
 	}
 
-    @Override
-    public AccessInterface prepareAccessInterface(AccessInterface access) {
-        return access;
-    }
-
-    @Override
-    public String getType() {
-        return "o " + containedTypeName;
-    }
-
-
-
+	@Override
+	public String getFramsTypeName() {
+		return "o " + containedTypeName;
+	}
 
 }
Index: java/main/src/main/java/com/framsticks/params/types/ProcedureParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/ProcedureParam.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/types/ProcedureParam.java	(revision 84)
@@ -1,9 +1,7 @@
 package com.framsticks.params.types;
 
-import com.framsticks.params.CastFailure;
-import com.framsticks.params.FramsClass;
 import com.framsticks.params.Param;
 import com.framsticks.params.ParamBuilder;
-import com.framsticks.util.Strings;
+import com.framsticks.util.lang.Strings;
 
 import java.util.ArrayList;
@@ -58,5 +56,5 @@
 
 	@Override
-	public Class getStorageType() {
+	public Class<?> getStorageType() {
 		return Void.class;
 	}
@@ -70,13 +68,8 @@
 	}
 
-    @Override
-    public Object reassign(Object newValue, Object oldValue) throws CastFailure {
-        throw new CastFailure();
-    }
-
-    @Override
-    public String getType() {
-        return "p";
-    }
+	@Override
+	public String getFramsTypeName() {
+		return "p";
+	}
 
 }
Index: java/main/src/main/java/com/framsticks/params/types/StringParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/StringParam.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/types/StringParam.java	(revision 84)
@@ -2,4 +2,6 @@
 
 import com.framsticks.params.CastFailure;
+import com.framsticks.params.PrimitiveParam;
+import com.framsticks.params.ReassignResult;
 import com.framsticks.params.SinkInterface;
 
@@ -7,35 +9,34 @@
  * @author Piotr Sniegowski
  */
-public class StringParam extends ValueParam {
+public class StringParam extends PrimitiveParam {
 	@Override
-	public Class getStorageType() {
+	public Class<?> getStorageType() {
 		return String.class;
 	}
 
 	@Override
-	public boolean isEmptyAvailable() {
-		return true;
+	public ReassignResult<String> reassign(Object newValue, Object oldValue) throws CastFailure {
+		if (newValue == null) {
+			return new ReassignResult<String>(null);
+		}
+		if (newValue instanceof String) {
+			return ReassignResult.create((String) newValue);
+		}
+		return ReassignResult.create(newValue.toString());
+		// return super.reassign(newValue, oldValue);
 	}
 
-    @Override
-    public Object reassign(Object newValue, Object oldValue) throws CastFailure {
-        if (newValue instanceof String) {
-            return (String)newValue;
-        }
-        return super.reassign(newValue, oldValue);
-    }
+	@Override
+	public String getFramsTypeName() {
+		return "s";
+	}
 
-    @Override
-    public String getType() {
-        return "s";
-    }
+	private static final String SEPARATOR = System.getProperty("line.separator");
 
-    private static final String SEPARATOR = System.getProperty("line.separator");
-
-    @Override
-    public void save(SinkInterface sink, Object value) {
-        assert value instanceof String;
-        String s = (String)value;
-        sink.print((s.contains(SEPARATOR) ? (s = "~" + SEPARATOR + s + "~") : s));
-    }
+	@Override
+	public void save(SinkInterface sink, Object value) {
+		assert value instanceof String;
+		String s = (String)value;
+		sink.print((s.contains(SEPARATOR) ? (s = "~" + SEPARATOR + s + "~") : s));
+	}
 }
Index: java/main/src/main/java/com/framsticks/params/types/UniqueListParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/UniqueListParam.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/types/UniqueListParam.java	(revision 84)
@@ -3,9 +3,9 @@
 import com.framsticks.params.AccessInterface;
 import com.framsticks.params.CastFailure;
+import com.framsticks.params.ReassignResult;
 import com.framsticks.params.UniqueListAccess;
-import com.framsticks.util.Numbers;
+import com.framsticks.util.lang.Numbers;
 
 import java.util.HashMap;
-import java.util.List;
 import java.util.Map;
 
@@ -15,53 +15,52 @@
 public class UniqueListParam extends ListParam {
 
-    final String uidName;
+	final String uidName;
 
-    public UniqueListParam(String containedTypeName, String uidName) {
-        super(containedTypeName);
-        this.uidName = uidName;
-    }
+	public UniqueListParam(String containedTypeName, String uidName) {
+		super(containedTypeName);
+		this.uidName = uidName;
+	}
 
-    @Override
-    public String computeAccessId() {
-        return "l " + containedTypeName + " " + uidName;
-    }
+	@Override
+	public String computeAccessId() {
+		return "l " + containedTypeName + " " + uidName;
+	}
 
 
-    @Override
-    public Class getStorageType() {
-        return Map.class;
-    }
+	@Override
+	public Class<?> getStorageType() {
+		return Map.class;
+	}
 
-    @Override
-    public AccessInterface prepareAccessInterface(AccessInterface access) {
-        return new UniqueListAccess(access, uidName);
-    }
+	@Override
+	public AccessInterface prepareAccessInterface(AccessInterface access) {
+		return new UniqueListAccess(access, uidName);
+	}
 
+	@Override
+	public ReassignResult<? extends Map<?,?>> reassign(Object newValue, Object oldValue) throws CastFailure {
+		if (newValue instanceof Map) {
+			return new ReassignResult<Map<?,?>>((Map<?,?>) newValue);
+		}
+		Integer size = Numbers.cast(newValue, Integer.class);
+		if (size != null) {
+			//return oldValue;
+			/*
+			the integer value should be ignored, because this may cause, that object is created before
+			information about it's elements is available, which would break resolution flow
+			*/
+			if (oldValue != null) {
+				return new ReassignResult<Map<?,?>>((Map<?,?>) oldValue);
+			}
+			return ReassignResult.create(new HashMap<Object, Object>());
+		}
 
-    @Override
-    public Object reassign(Object newValue, Object oldValue) throws CastFailure {
-        if (newValue instanceof Map) {
-            return newValue;
-        }
-        Integer size = Numbers.cast(newValue, Integer.class);
-        if (size != null) {
-            //return oldValue;
-            /*
-            the integer value should be ignored, because this may cause, that object is created before
-            information about it's elements is available, which would break resolution flow
-            */
-            if (oldValue != null) {
-                return oldValue;
-            }
-            return new HashMap();
-        }
+		throw new CastFailure();
+	}
 
-        throw new CastFailure();
-    }
-
-    @Override
-    public String getType() {
-        return "l " + containedTypeName + " " + uidName;
-    }
+	@Override
+	public String getFramsTypeName() {
+		return "l " + containedTypeName + " " + uidName;
+	}
 
 
Index: java/main/src/main/java/com/framsticks/params/types/UniversalParam.java
===================================================================
--- java/main/src/main/java/com/framsticks/params/types/UniversalParam.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/params/types/UniversalParam.java	(revision 84)
@@ -2,25 +2,25 @@
 
 import com.framsticks.params.CastFailure;
-import com.framsticks.util.Numbers;
+import com.framsticks.params.PrimitiveParam;
+import com.framsticks.params.ReassignResult;
 
 /**
  * @author Piotr Sniegowski
  */
-public class UniversalParam extends ValueParam {
+public class UniversalParam extends PrimitiveParam {
 	@Override
-	public Class getStorageType() {
+	public Class<?> getStorageType() {
 		return Object.class;
 	}
 
 	@Override
-	public boolean isEmptyAvailable() {
-		return true;
+	public String getFramsTypeName() {
+		return "x";
 	}
 
-    @Override
-    public String getType() {
-        return "x";
-    }
-
+	@Override
+	public ReassignResult<Object> reassign(Object newValue, Object oldValue) throws CastFailure {
+		return ReassignResult.create(newValue);
+	}
 
 }
Index: java/main/src/main/java/com/framsticks/parsers/F0Parser.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 79)
+++ java/main/src/main/java/com/framsticks/parsers/F0Parser.java	(revision 84)
@@ -7,4 +7,5 @@
 import java.text.ParseException;
 import java.util.ArrayList;
+import java.util.Collection;
 import java.util.List;
 
@@ -14,7 +15,9 @@
 import com.framsticks.params.Flags;
 import com.framsticks.params.Param;
-import com.framsticks.util.Exceptions;
-import com.framsticks.util.Pair;
-import com.framsticks.util.Strings;
+import com.framsticks.params.PrimitiveParam;
+import com.framsticks.util.lang.Containers;
+import com.framsticks.util.lang.Exceptions;
+import com.framsticks.util.lang.Pair;
+import com.framsticks.util.lang.Strings;
 import org.apache.log4j.Logger;
 
@@ -27,5 +30,5 @@
 public class F0Parser {
 
-	private final static Logger LOGGER = Logger.getLogger(F0Parser.class);
+	private final static Logger log = Logger.getLogger(F0Parser.class);
 
 	/** The schema proper for f0 representation. */
@@ -71,5 +74,5 @@
 	 * fields (bigger than maximum or smaller than minimum values) are
 	 * communicated by warnings and set to minimum / maximum value.
-	 * 
+	 *
 	 * @return the list
 	 * @throws IOException
@@ -91,5 +94,5 @@
 				if (lineNumber == 1) {
 					if (!"//0".equals(line)) {
-						LOGGER.warn("stream should begin with \"//0\" in the first line");
+						log.warn("stream should begin with \"//0\" in the first line");
 					} else {
 						continue;
@@ -122,5 +125,5 @@
 
 	private static void warn(int lineNumber, String message, Exception e) {
-		LOGGER.warn("in line " + lineNumber + " the following error occurred (" + message + "): " + e + "\n" + Exceptions.printStackTrace(e));
+		log.warn("in line " + lineNumber + " the following error occurred (" + message + "): " + e + "\n" + Exceptions.printStackTrace(e));
 	}
 
@@ -175,9 +178,10 @@
 		List<Exception> exceptions = new ArrayList<Exception>();
 
-		Param[] params = access.getParams().toArray(new Param[] {null});
+		Collection<Param> paramsC = access.getParams();
+		Param[] params = paramsC.toArray(new Param[] {null});
 		if (params.length == 0) {
 			return exceptions;
 		}
-		for (Param p : params) {
+		for (PrimitiveParam p : Containers.filterInstanceof(paramsC, PrimitiveParam.class)) {
 			Object def = p.getDef(Object.class);
 			if (def != null) {
@@ -210,14 +214,14 @@
 					currentParam = params[nextParamNumber];
 				}
-
 				if (currentParam != null) {
 					if (pair.value != null) {
-						int setFlag = access.set(currentParam, pair.value);
+						PrimitiveParam vp = (PrimitiveParam) currentParam;
+						int setFlag = access.set(vp, pair.value);
 						if ((setFlag & Flags.PSET_HITMIN) != 0) {
-							exceptions.add(createBoundaryHitException(access, currentParam, pair.value, Flags.PSET_HITMIN));
+							exceptions.add(createBoundaryHitException(access, vp, pair.value, Flags.PSET_HITMIN));
 						}
 
 						if ((setFlag & Flags.PSET_HITMAX) != 0) {
-							exceptions.add(createBoundaryHitException(access, currentParam, pair.value, Flags.PSET_HITMAX));
+							exceptions.add(createBoundaryHitException(access, vp, pair.value, Flags.PSET_HITMAX));
 						}
 
@@ -243,5 +247,5 @@
 	}
 
-	private static Exception createBoundaryHitException(AccessInterface access, Param param, String value, int flag) {
+	private static Exception createBoundaryHitException(AccessInterface access, PrimitiveParam param, String value, int flag) {
 		boolean minimum = (flag & Flags.PSET_HITMIN) != 0;
 		String boundary = (minimum ? param.getMin(Object.class) : param.getMax(Object.class)).toString();
Index: java/main/src/main/java/com/framsticks/parsers/F0Writer.java
===================================================================
--- java/main/src/main/java/com/framsticks/parsers/F0Writer.java	(revision 84)
+++ java/main/src/main/java/com/framsticks/parsers/F0Writer.java	(revision 84)
@@ -0,0 +1,86 @@
+package com.framsticks.parsers;
+
+import com.framsticks.model.Model;
+import com.framsticks.params.*;
+import com.framsticks.util.Misc;
+import com.framsticks.util.lang.Containers;
+import static com.framsticks.util.lang.Containers.filterInstanceof;
+
+/**
+ * Author: Piotr Śniegowski
+ */
+public class F0Writer {
+
+	protected final Schema schema;
+	protected final SinkInterface sink;
+	protected final Model model;
+	protected boolean omit = true;
+
+	public F0Writer(Schema schema, Model model, SinkInterface sink) {
+		this.schema = schema;
+		this.model = model;
+		this.sink = sink;
+	}
+
+	F0Writer omitDefaultValues(boolean omit) {
+		this.omit = omit;
+		return this;
+	}
+
+	protected void write(AccessInterface access) {
+		if (access instanceof ListAccess) {
+			// TODO
+			for (ValueParam p : Containers.filterInstanceof(access.getParams(), ValueParam.class)) {
+				write(schema.getRegistry().prepareAccess((CompositeParam) p).select(access.get(p, Object.class)));
+			}
+			return;
+		}
+		StringBuilder line = new StringBuilder();
+		line.append(access.getId()).append(":");
+		boolean placeComma = false;
+		boolean contiguous = true;
+
+		for (ValueParam param : filterInstanceof(access.getParams(), ValueParam.class)) {
+			if (param instanceof CompositeParam) {
+				AccessInterface a = schema.getRegistry().prepareAccess((CompositeParam)param);
+				a.select(access.get((ValueParam) param, Object.class));
+				write(a);
+				continue;
+			}
+			Object value = access.get(param, Object.class);
+			if ((param instanceof PrimitiveParam) && Misc.equals(value, ((PrimitiveParam) param).getDef(Object.class))) {
+				contiguous = false;
+				continue;
+			}
+			if (value == null) {
+				contiguous = false;
+				continue;
+			}
+
+			if (placeComma) {
+				line.append(",");
+			} else {
+				placeComma = true;
+			}
+
+			if ((!contiguous) || ((param.getFlags() & Flags.CANOMITNAME) == 0)) {
+				line.append(param.getId()).append("=");
+				contiguous = true;
+			}
+			String printed = value.toString().replace("\"", "\\\"");
+			if (printed.contains(",")) {
+				line.append("\"").append(printed).append("\"");
+			} else {
+				line.append(value);
+			}
+		}
+		sink.print(line).breakLine();
+	}
+	public void write() {
+		AccessInterface access = schema.getRegistry().createAccess("m");
+		access.select(model);
+		write(access);
+	}
+
+
+}
